<?php

/**
 * 商品数据模型 *
 * @author jgao
 */
class GoodsItemModel
{
    //put your code here

    /**
     * 手动id
     * @var type
     */
    public $id;

    /**
     * 名称
     * @var string
     */
    public $name;

    /**
     * 封包类型 1=单一物品 2=多个物品
     * @var int
     */
    public $packageType;

    /**
     * 商店第一级菜单 1=龙蛋 2=栖息地 3=建筑 4=装饰 5=兑换
     * @var type
     */
    public $shopFist;

    /**
     * 商店2级菜单 数组 同时存在多个菜单中 [1, 2, 3]
     * @var type
     */
    public $shopSecond;

    /**
     * 内容 一个对象 里面是物品的id:数量 金币id=1 宝石=2 食物=3 ...
     * @var type
     */
    public $content;

    /**
     * 获取方式 1=商店出售 2=每日领取 3=目标奖励 4=活动奖励
     * @var type
     */
    public $getType;

    /**
     * 商店出售价格 {"g":100} 金币和宝石
     * @var type
     */
    public $prize;

    /**
     * 商店定价-钻石
     * @var int 钻石定价
     */
    public $cashPrice;

    /**
     * 商店定价-金币
     * @var int 金币定价
     */
    public $goldPrice;

    /**
     *  二级货币价格
     * @var type
     */
    public $cost;

    /**
     * 商店折扣是否开启
     * @var type
     */
    public $isDiscount;

    /**
     * 折扣开始时间戳
     * @var int
     */
    public $discountStartTs;

    /**
     * 折扣结束时间戳
     * @var int
     */
    public $discountEndTs;

    /**
     * 折扣数量(1~100,100为不打折)
     * @var int
     */
    public $discountRate;

    /**
     * 是否上架 1=上架, 0=否,非卖品
     * @var type
     */
    public $forSale;

    /**
     * 物品图片
     * @var type
     */
    public $iamge;

    /**
     * 是否新品
     * @var type
     */
    public $isNew;

    /**
     * 额外属性 {"isActive":true},活动物品
     * @var type
     */
    public $properties;

    /**
     * 商品描述
     * @var string
     */
    public $describe;

}
