<?php

namespace loyalsoft;

/*
 * 功能: 内存数据库操作基类
 * version:
 *
 */

/**
 * Description of CMemBase
 * CMemNoSqL db 操作基类
 * @author gwang (mail@wanggangzero.cn)
 */
abstract class CMemBase {

    /**
     * 连接
     */
    abstract public function conn($host, $port, $pwd = "");

    /**
     * 查询/获取 指定 key 对应的value
     */
    abstract public function get($key);

    abstract public function set($key, $value, $ts = 0);

    /**
     * 取没有进行json编码的数据
     * @param type $key

     * @return type
     */
    abstract public function getWithoutJson($key);

    /**
     * 设置值,内部不加 json_encode
     * @param string $key
     * @param string $value
     * @param seconds $ts
     * @return boolean
     */
    abstract public function setWithoutJson($key, $value, $ts = 0);

    /**
     * 给某个指定数据 加上 指定的数值
     */
    abstract public function add($key, $value, $ts = 0);

    /**
     * 替换某条数据
     */
    abstract public function replace($key, $value, $ts = 0);

    /**
     * 删除某条指定的数据
     */
    abstract public function delete($key);

    /**
     * 给指定的key所对应的值增加1
     */
    abstract public function increment($key);

    /**
     * 一次取多个值
     */
    abstract public function getMulti($keys);

    /**
     * 一次设置多个值
     * @param array $dict [{"key":value},{"key":value}, ...]
     * @param int $expireTs 超时时间
     */
    abstract public function setMutlti($dict, $expireTs = 0);

//    /**
//     * Compare and set 比较并且(结果相同则)写入
//     */
//    abstract public function cas($key, $value, $ts);

    /**
     * 复制
     */
    abstract public function copy($surKey, $desKey);

    /**
     * 关闭连接
     */
    abstract public function close();
}
